/***************************************************************************
                          knobdial.h  -  description
                             -------------------
    begin                : Sun Ju 7 2002
    copyright            : (C) 2002 by Krzysztof Lichota
    email                : lichota@mimuw.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qdial.h>
#include <qcolor.h>
 
class KnobDialProperties
{
public:
	bool drawCross;
	QColor crossColor;
};
 
class KnobDial: public QDial
{
    Q_OBJECT
public:
	KnobDial(QWidget *parent=0, const char *name=0 );
	virtual void repaintScreen( const QRect *cr =0);

	KnobDialProperties getDialProperties() { return this->properties; }
	void setDialProperties(const KnobDialProperties& props) { this->properties = props; }

signals:
	void middleClick();
	
private:
	KnobDialProperties properties;

	void mouseReleaseEvent(QMouseEvent *e);
	void mousePressEvent(QMouseEvent *e);
};
