/***************************************************************************
                          volume.h  -  description
                             -------------------
    begin                : Thu Jul 18 2002
    copyright            : (C) 2002 by Krzysztof Lichota
    email                : lichota@mimuw.edu.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//FIXME: use kmix objects
 
class KnobVolumeCtrl
{
public:
	KnobVolumeCtrl();
	//returns volume set on mixer, or -1 in case of error
	virtual int getVolume() { return -1; };

	//returns false in case of error
	virtual bool setVolume(int volume) { return false; };

	virtual bool isMuted();

	virtual void mute();
	virtual void unMute();

protected:
	bool muted;

	int unmutedVolume;
};

class KnobVolumeCtrl_OSS: public KnobVolumeCtrl
{
public:
	virtual bool setVolume(int volume);
	virtual int getVolume();

	KnobVolumeCtrl_OSS() { this->error = false; }
	
protected:
	//taken from asmixer
	typedef struct 
	{
  		unsigned char left;
		unsigned char right;
	} StereoVolume;

	typedef struct
	{
		int mixer_id;
		StereoVolume volume;
		int supported;
	} VolumeControl;

	VolumeControl volControl;
	int mixerFd;

	bool openMixer();
	void closeMixer();

	//flag set when error happens to avoid continuous reporting of the same error
	bool error;
};
